%global pkg qla2xxx
%global kernel 5.10.134-17.an8
%define pkg_version 10.02.09.00_k
%define anolis_release 13

%define __strip /bin/true
%define dup_state_dir           %{_localstatedir}/lib/rpm-state/kmod-dups
%define kver_state_dir          %{dup_state_dir}/kver
%define kver_state_file         %{kver_state_dir}/%{kernel}
%global kernel_source()         /usr/src/kernels/%{kernel}
%define vendor %{dvendor}
%define dvendor	qlgc

Name:        kmod-%{pkg}
Version:     %(echo %{kernel} | sed -E 's/-/~/g; s/\.(an|al)[0-9]+$//g')
Release:     %{pkg_version}~%{anolis_release}%{?dist}
Summary:       QLogic qlaxxx FC Driver Update Program package
Group:         System/Kernel
License:       GPLv2
Vendor:       QLogic Corp.
Packager:       QLogic Corp.

URL:	      http://www.qlogic.com
Source:       kmod-%{pkg}-%{pkg_version}.tar.gz
# Source2:	dracut.qla2xxx.conf
# Source3:	99-qla2xxx.rules
# Source4:	qla2xxx_udev.sh

BuildRoot:     %(mktemp -ud %{_tmppath}/%{name}-src-%{dist_version}-%{release}-XXXXXX)
BuildRequires:  elfutils-libelf-devel
BuildRequires:  kernel-devel = %{kernel}

Obsoletes: hpqlgc-%{pkg}
Conflicts: hpqlgc-%{pkg}

Requires: kmod

%global debug_package %{nil}

%description
RHEL7.x Driver Update package for QLogic FC Adapter.
Public key available at http://ldriver.qlogic.com/RPM-public-key/
SRPMS available at http://ldriver.qlogic.com/driver-srpms/


%prep
%setup -n kmod-%{pkg}-%{pkg_version}
echo "override %{pkg} * weak-updates/%{dvendor}-%{pkg}" > %{pkg}.conf

%build
make -C /usr/src/kernels/%{kernel}.%{_arch}/ KVER=%{kernel}.%{_arch} M=$PWD/src -j32

%install
mkdir -p %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/drivers/scsi/%{pkg}
make -C /usr/src/kernels/%{kernel}.%{_arch}/ INSTALL_MOD_PATH=%{buildroot} INSTALL_MOD_DIR=/extra/drivers/scsi/%{pkg} M=$PWD/src modules_install
# Cleanup unnecessary kernel-generated module dependency files.
find %{buildroot}/lib/modules -iname 'modules.*' -exec rm {} \;

find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+

%{__install} -d %{buildroot}/%{_sysconfdir}/depmod.d/
%{__install} %{pkg}.conf %{buildroot}/%{_sysconfdir}/depmod.d/
mkdir -p %{buildroot}/etc/dracut.conf.d
%{__install} -m 755 dracut.qla2xxx.conf %{buildroot}/etc/dracut.conf.d/qla2xxx.conf
for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
    echo "override $(basename $kmod .ko) * extra/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
done
mkdir -p %{buildroot}/etc/udev/rules.d/
%{__install} -m 644 99-qla2xxx.rules %{buildroot}/etc/udev/rules.d/

mkdir -p %{buildroot}/lib/udev
%{__install} -m 744 qla2xxx_udev.sh %{buildroot}/lib/udev/

%post
depmod -a > /dev/null 2>&1

if [ -e "/boot/System.map-%{kernel}.%{_arch}" ]; then
        %{_sbindir}/depmod -aeF "/boot/System.map-%{kernel}.%{_arch}" "%{kernel}.%{_arch}" > /dev/null || :
fi
modules=( $(find /lib/modules/%{kernel}.%{_arch}/extra/drivers/scsi/%{pkg} | grep '\qla2xxx.ko$') )
printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --add-modules

mkdir -p "%{kver_state_dir}"
touch "%{kver_state_file}"

%preun
mkdir -p "%{dup_state_dir}"
rpm -ql kmod-%{pkg} | \
        grep '\.ko$' > "%{dup_module_list}"

%postun
depmod -a > /dev/null 2>&1

if [ -e "/boot/System.map-%{kernel}.%{_arch}" ]; then
        %{_sbindir}/depmod -aeF "/boot/System.map-%{kernel}.%{_arch}" "%{kernel}.%{_arch}" > /dev/null || :
fi
modules=( $(cat "%{dup_module_list}") )
printf '%s\n' "${modules[@]}" | %{_sbindir}/weak-modules --dracut=/usr/bin/dracut --remove-modules


%files
/etc/depmod.d/qla2xxx.conf
/etc/dracut.conf.d/qla2xxx.conf
/etc/udev/rules.d/99-qla2xxx.rules
/lib/udev/qla2xxx_udev.sh
/lib/modules/%{kernel}.%{_arch}
%license licenses/LICENSE.qla2xxx
%dir /lib/modules/%{kernel}.%{_arch}/extra/drivers/scsi/%{pkg}
%clean
rm -rf %{buildroot}

%changelog
* Fri Jul 19 2024 daichx <daichx@inspur.com> - 10.02.09.00_k
- init qla2xxx
